<?php
!function_exists('readover') && exit('Forbidden');
$basename="$admin_file?adminjob=modeset";
if (!$action) {

	if ($fp = opendir(R_P.'mode')) {
		if ($db_mode) {
			$defalutchecked = '';
		} else {
			$defalutchecked = 'checked="checked"';
		}
		$modes = $infodb = array();
		while (($modedir = readdir($fp))) {
			if (strpos($modedir,'.')===false) {
				$modename = $modedir;
				$modeuse = $db_mode == $modename ? 1 : 0;
				if (function_exists('file_get_contents')) {
					$filedata = @file_get_contents(R_P."mode/$modedir/info.xml");
				} else {
					$filedata = readover(R_P."mode/$modedir/info.xml");
				}
				if (preg_match('/\<modename\>(.+?)\<\/modename\>\s+\<descrip\>(.+?)\<\/descrip\>/is',$filedata,$infodb)) {
					$infodb[1] && $modename = Char_cv(str_replace(array("\n"),'',$infodb[1]));
					$modedescrip = Char_cv(str_replace(array("\n"),'',$infodb[2]));
				}
				$modes[] = array($modename,$modedescrip,$modeuse,$modedir);
			}
		}
		closedir($fp);
	}

} elseif ($action == 'install') {
	InitGP('mode','P','1');
	if ($mode && $mode!=$db_mode) {
		!file_exists(R_P.'mode/'.$mode) && adminmsg('mode_no_directory');
		!file_exists(R_P.'mode/'.$mode.'/info.xml') && adminmsg('mode_no_info');
		if (function_exists('file_get_contents')) {
			$filedata = @file_get_contents(R_P."mode/$mode/info.xml");
		} else {
			$filedata = readover(R_P."mode/$mode/info.xml");
		}

		$params = xml2array($filedata);
		if ($params['forumtype']['item']) {
			$forumtype = array();
			$items = $params['forumtype']['item'];
			foreach ($items as $value) {
				$forumtype[] = array($value['typename'],$mode,$value['mark'],$value['allowtype'],serialize($value['config']));
			}
			if ($forumtype) {
				$db->update("REPLACE INTO pw_forumtype(typename,mode,mark,allowtype,config) VALUES".pwSqlMulti($forumtype));
			}
		}
		$rt = $db->get_one("SELECT db_name FROM pw_config WHERE db_name='db_mode'");
		if (!empty($rt)) {
			$db->update("UPDATE pw_config SET db_value=".pwEscape($mode,false)."WHERE db_name='db_mode'");
		} else {
			$db->update("INSERT INTO pw_config SET db_name='db_mode',db_value=".pwEscape($mode));
		}
		$db_mode = $mode;

		if ($params['pages']['item']) {
			$items = $params['pages']['item'];
			$pages = array();
			foreach ($items as $value) {
				!$value['scr'] && $value['scr'] = 'public';
				$pages[$value['template']] = array('name'=>$value['name'],'template'=>$value['template'],'scr'=>$value['scr']);
			}
			if ($pages) {
				$pages = serialize($pages);
			} else {
				$pages = '';
			}

			$rt = $db->get_one("SELECT db_name FROM pw_config WHERE db_name='db_modepages'");
			if (!empty($rt)) {
				$db->update("UPDATE pw_config SET db_value=".pwEscape($pages,false)." WHERE db_name='db_modepages'");
			} else {
				$db->update("INSERT INTO pw_config SET db_name='db_modepages',db_value=".pwEscape($pages,false));
			}
		}
		if ((int) $params['ifpwcache']) {
			$params['ifpwcache'] = (int) $params['ifpwcache'];
			$rt = $db->get_one("SELECT db_name FROM pw_config WHERE db_name='db_ifpwcache'");
			if (!empty($rt)) {
				$db->update("UPDATE pw_config SET db_value=db_value|".$params['ifpwcache']." WHERE db_name='db_ifpwcache'");
			} else {
				$db->update("INSERT INTO pw_config SET db_name='db_ifpwcache',db_value=".pwEscape($params['ifpwcache']));
			}
		}
		if (file_exists(R_P."mode/$mode/pageconfig.txt")) {
			$str = readover(R_P."mode/$mode/pageconfig.txt");
			$importInfo = base64_decode($str);
			$importInfo = unserialize($importInfo);
			if (is_array($importInfo) && $importInfo['modename']==$mode) {
				unset($importInfo['modename']);
				foreach ($importInfo as $key=>$value) {
					if (!file_exists(D_P.'data/bbscache/mode_'.$key.'_'.$db_mode.'_config.php')) {
						writeover(D_P.'data/bbscache/mode_'.$key.'_'.$db_mode.'_config.php',"<?php\r\n\$".$key."_config = ".pw_var_export($value)."\r\n?>");
					}
				}
			}
		}
		$fp = opendir(D_P.'data/tplcache/');
		while ($filename = readdir($fp)) {
			if($filename=='..' || $filename=='.' || strpos($filename,'.htm')===false) continue;
			@unlink(Pcv(D_P.'data/tplcache/'.$filename));
		}
		closedir($fp);
	} elseif (!$mode) {
		$rt = $db->get_one("SELECT db_name FROM pw_config WHERE db_name='db_mode'");
		if (!empty($rt)) {
			$db->update("UPDATE pw_config SET db_value='' WHERE db_name='db_mode'");
		} else {
			$db->update("INSERT INTO pw_config SET db_name='db_mode',db_value=''");
		}
		$db_mode = '';
	}
	updatecache_c();
	adminmsg('operate_success');

} elseif ($action == 'fourmtypeset') {
	InitGP('step','P','1');
	!$db_mode && adminmsg('mode_have_noopen');
	if ($step == 2) {
		InitGP(array('forumtype','catedbs'),'P',1);
		$typyallowtype = $updatelist = array();
		$query = $db->query("SELECT mark,allowtype FROM pw_forumtype WHERE mode=".pwEscape($db_mode));
		while ($rt = $db->fetch_array($query)) {
			$updatelist[$rt['mark']] = array();
			$typyallowtype[$rt['mark']] = (int)$rt['allowtype'];
		}
		foreach ($forumtype as $key => $value) {
			if ($value && array_key_exists($value,$updatelist)) {
				$updatelist[$value][] = $key;
			} else {
				$updatelist['0'][] = $key;
			}
		}
		foreach ($updatelist as $key => $value) {
			if (count($value)) {
				$sqladd = '';
				if ($typyallowtype[$key]) {
					$sqladd .= ',allowtype=allowtype|'.$typyallowtype[$key];
				}
				$db->update("UPDATE pw_forums SET forumtype=".pwEscape($key,false)."$sqladd WHERE fid IN(".pwImplode($value).")");
			}
		}
		updatecache_f();
		writeover(D_P.'data/bbscache/catedbs_'.$db_mode.'_cache.php',"<?php\r\n\$catedbs=".pw_var_export($catedbs).";\r\n?>");
		adminmsg('operate_success',$basename."&action=fourmtypeset");
	} else {
		@include_once(D_P.'data/bbscache/catedbs_'.$db_mode.'_cache.php');
		if (!$catedbs) {
			$catedbs = array();
		}
		$forumtypes = '<select class="input" name="forumtype" ><option value="0"> </option>';
		$query = $db->query("SELECT * FROM pw_forumtype WHERE mode=".pwEscape($db_mode));
		while ($rt = $db->fetch_array($query)) {
			$forumtypes .= "<option value=\"$rt[mark]\">$rt[typename]</option>";
		}
		$forumtypes .= "</select>";
		$catedb = $forumdb = $subdb1 = $subdb2 = array();
		$space  = '<span class="fourm-two"></span>';

		$query = $db->query("SELECT fid,fup,type,name,vieworder,forumadmin,f_type,cms,forumtype FROM pw_forums WHERE cms!='1' ORDER BY vieworder");
		while ($forums = $db->fetch_array($query)) {
			$forums['name'] = preg_replace("/\<(.+?)\>/is","",$forums['name']);//ȥhtmlǩ
			$forums['name'] = str_replace("<","&lt;",$forums['name']);
			$forums['name'] = str_replace(">","&gt;",$forums['name']);
			if ($forums['type'] != 'category') {
				if ($forums['forumtype']) {
					$forums['forumtype'] = str_replace(array("value=\"$forums[forumtype]\"","name=\"forumtype\""),array("value=\"$forums[forumtype]\" selected=\"selected\"","name=\"forumtype[$forums[fid]]\""),$forumtypes);
				} else {
					$forums['forumtype'] = str_replace("name=\"forumtype\"","name=\"forumtype[$forums[fid]]\"",$forumtypes);
				}
			} else {
				$forums['forumtype'] = array_key_exists($forums['fid'],$catedbs) ? $catedbs[$forums['fid']] : $forums['name'];
			}
			if ($forums['type'] == 'category') {
				$catedb[] = $forums;
			} elseif ($forums['type'] == 'forum') {
				$forumdb[] = $forums;
			} elseif ($forums['type'] == 'sub') {
				//$subdb1[] = $forums;
			} else {
				//$subdb2[] = $forums;
			}
		}
		$threaddb = array();
		foreach ($catedb as $cate) {
			$threaddb[] = $cate;
			foreach ($forumdb as $key2 => $forumss) {
				if ($forumss['fup'] == $cate['fid']) {
					$threaddb[] = $forumss;
					unset($forumdb[$key2]);
					foreach ($subdb1 as $key3 => $sub1) {
						if ($sub1['fup'] == $forumss['fid']) {
							$threaddb[] = $sub1;
							unset($subdb1[$key3]);
							foreach ($subdb2 as $key4 => $sub2) {
								if ($sub2['fup'] == $sub1['fid']) {
									$threaddb[] = $sub2;
									unset($subdb2[$key4]);
								}
							}
						}
					}
				}
			}
		}
	}
} elseif ($action == 'fourmtypecache') {
	!$db_mode && adminmsg('mode_have_noopen');
	$fp = opendir(D_P.'data/bbscache/');
	while ($filename = readdir($fp)) {
		if($filename=='..' || $filename=='.') continue;
		if (strpos($filename,'mode_'.$db_mode) !==false) {
			P_unlink(Pcv(D_P.'data/bbscache/'.$filename));
		}
	}
	closedir($fp);
	$fp = opendir(D_P.'data/tplcache/');
	while ($filename = readdir($fp)) {
		if($filename=='..' || $filename=='.' || strpos($filename,'.htm')===false) continue;
		P_unlink(Pcv(D_P.'data/tplcache/'.$filename));
	}
	closedir($fp);
	$fp = opendir($attachdir.'/mini/');
	while ($filename = readdir($fp)) {
		if($filename=='..' || $filename=='.') continue;
		P_unlink(Pcv($attachdir.'/mini/'.$filename));
	}
	closedir($fp);
	adminmsg('operate_success');
}
include PrintEot('modeset');exit;

function xml2array($content){
	$temp_array = array();
	if (preg_match('/<ifpwcache>(\d+)<\/ifpwcache>/i',$content,$match)) {
		$temp_array['ifpwcache'] = $match['1'];
	}
	$match_1 = $match_2 = array();
	if (preg_match('/<forumtype>([^\x00]*?)<\/forumtype>/i',$content,$match_1)) {
		if(preg_match_all('/<item>[^\x00]*?<typename>(.*?)<\/typename>[^\x00]*?<mark>(.*?)<\/mark>[^\x00]*?<allowtype>(\d+)<\/allowtype>[^\x00]*?<\/item>/i',$match_1[1],$match_2)) {
			foreach ($match_2[1] as $key => $value) {
				$temp_array['forumtype']['item'][$key]['typename']	= $value;
				$temp_array['forumtype']['item'][$key]['mark']		= $match_2[2][$key];
				$temp_array['forumtype']['item'][$key]['allowtype'] = $match_2[3][$key];
			}
		}
	}
	$match_1 = $match_2 = array();
	if (preg_match('/<pages>([^\x00]*?)<\/pages>/i',$content,$match_1)) {
		if(preg_match_all('/<item>[^\x00]*?<name>(.*?)<\/name>[^\x00]*?<template>(.*?)<\/template>[^\x00]*?<scr>(.*?)<\/scr>[^\x00]*?<\/item>/i',$match_1[1],$match_2)) {
			foreach ($match_2[1] as $key => $value) {
				$temp_array['pages']['item'][$key]['name']		= $value;
				$temp_array['pages']['item'][$key]['template']	= $match_2[2][$key];
				$temp_array['pages']['item'][$key]['scr']		= $match_2[3][$key];
			}
		}
	}
	return $temp_array;
}

?>